diff --git a/gcc/analyzer/engine.cc b/gcc/analyzer/engine.cc
index 1e2ae2b5655..0808cadeeef 100644
--- a/gcc/analyzer/engine.cc
+++ b/gcc/analyzer/engine.cc
@@ -68,87 +68,6 @@ along with GCC; see the file COPYING3.  If not see
 
 namespace ana {
 
-/* class impl_region_model_context : public region_model_context.  */
-
-impl_region_model_context::
-impl_region_model_context (exploded_graph &eg,
-			   const exploded_node *enode_for_diag,
-			   const program_state *old_state,
-			   program_state *new_state,
-			   state_change *change,
-			   const gimple *stmt,
-			   stmt_finder *stmt_finder)
-: m_eg (&eg), m_logger (eg.get_logger ()),
-  m_enode_for_diag (enode_for_diag),
-  m_old_state (old_state),
-  m_new_state (new_state),
-  m_change (change),
-  m_stmt (stmt),
-  m_stmt_finder (stmt_finder),
-  m_ext_state (eg.get_ext_state ())
-{
-}
-
-impl_region_model_context::
-impl_region_model_context (program_state *state,
-			   state_change *change,
-			   const extrinsic_state &ext_state,
-			   logger *logger)
-: m_eg (NULL), m_logger (logger), m_enode_for_diag (NULL),
-  m_old_state (NULL),
-  m_new_state (state),
-  m_change (change),
-  m_stmt (NULL),
-  m_stmt_finder (NULL),
-  m_ext_state (ext_state)
-{
-}
-
-void
-impl_region_model_context::warn (pending_diagnostic *d)
-{
-  LOG_FUNC (get_logger ());
-  if (m_eg)
-    m_eg->get_diagnostic_manager ().add_diagnostic
-      (m_enode_for_diag, m_enode_for_diag->get_supernode (),
-       m_stmt, m_stmt_finder, d);
-}
-
-void
-impl_region_model_context::remap_svalue_ids (const svalue_id_map &map)
-{
-  m_new_state->remap_svalue_ids (map);
-  if (m_change)
-    m_change->remap_svalue_ids (map);
-}
-
-int
-impl_region_model_context::on_svalue_purge (svalue_id first_unused_sid,
-					    const svalue_id_map &map)
-{
-  int total = 0;
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = m_ext_state.get_sm (sm_idx);
-      total += smap->on_svalue_purge (sm, sm_idx, first_unused_sid,
-				      map, this);
-    }
-  if (m_change)
-    total += m_change->on_svalue_purge (first_unused_sid);
-  return total;
-}
-
-void
-impl_region_model_context::on_unknown_change (svalue_id sid)
-{
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    smap->on_unknown_change (sid);
-}
-
 /* class impl_region_model2_context : public region_model_context.  */
 
 impl_region_model2_context::
@@ -156,14 +75,12 @@ impl_region_model2_context (exploded_graph &eg,
 			   const exploded_node *enode_for_diag,
 			   const program_state *old_state,
 			   program_state *new_state,
-			   state_change *change,
 			   const gimple *stmt,
 			   stmt_finder *stmt_finder)
 : m_eg (&eg), m_logger (eg.get_logger ()),
   m_enode_for_diag (enode_for_diag),
   m_old_state (old_state),
   m_new_state (new_state),
-  m_change (change),
   m_stmt (stmt),
   m_stmt_finder (stmt_finder),
   m_ext_state (eg.get_ext_state ())
@@ -172,13 +89,11 @@ impl_region_model2_context (exploded_graph &eg,
 
 impl_region_model2_context::
 impl_region_model2_context (program_state *state,
-			   state_change *change,
-			   const extrinsic_state &ext_state,
-			   logger *logger)
+			    const extrinsic_state &ext_state,
+			    logger *logger)
 : m_eg (NULL), m_logger (logger), m_enode_for_diag (NULL),
   m_old_state (NULL),
   m_new_state (state),
-  m_change (change),
   m_stmt (NULL),
   m_stmt_finder (NULL),
   m_ext_state (ext_state)
@@ -235,44 +150,6 @@ impl_region_model2_context::on_unknown_change (const svalue2 *sval,
     }
 }
 
-/* class setjmp_svalue : public svalue.  */
-
-/* Compare the fields of this setjmp_svalue with OTHER, returning true
-   if they are equal.
-   For use by svalue::operator==.  */
-
-bool
-setjmp_svalue::compare_fields (const setjmp_svalue &other) const
-{
-  return m_setjmp_record == other.m_setjmp_record;
-}
-
-/* Implementation of svalue::add_to_hash vfunc for setjmp_svalue.  */
-
-void
-setjmp_svalue::add_to_hash (inchash::hash &hstate) const
-{
-  hstate.add_int (m_setjmp_record.m_enode->m_index);
-}
-
-/* Get the index of the stored exploded_node.  */
-
-int
-setjmp_svalue::get_enode_index () const
-{
-  return m_setjmp_record.m_enode->m_index;
-}
-
-/* Implementation of svalue::print_details vfunc for setjmp_svalue.  */
-
-void
-setjmp_svalue::print_details (const region_model &model ATTRIBUTE_UNUSED,
-			      svalue_id this_sid ATTRIBUTE_UNUSED,
-			      pretty_printer *pp) const
-{
-  pp_printf (pp, "setjmp: EN: %i", get_enode_index ());
-}
-
 /* class setjmp_svalue2 : public svalue2.  */
 
 /* FIXME.  */
@@ -323,183 +200,6 @@ setjmp_svalue2::get_enode_index () const
   return m_setjmp_record.m_enode->m_index;
 }
 
-/* Concrete implementation of sm_context, wiring it up to the rest of this
-   file.  */
-
-class impl_sm_context : public sm_context
-{
-public:
-  impl_sm_context (exploded_graph &eg,
-		   int sm_idx,
-		   const state_machine &sm,
-		   const exploded_node *enode_for_diag,
-		   const program_state *old_state,
-		   program_state *new_state,
-		   state_change *change,
-		   const sm_state_map *old_smap,
-		   sm_state_map *new_smap,
-		   stmt_finder *stmt_finder = NULL)
-  : sm_context (sm_idx, sm),
-    m_logger (eg.get_logger ()),
-    m_eg (eg), m_enode_for_diag (enode_for_diag),
-    m_old_state (old_state), m_new_state (new_state),
-    m_change (change),
-    m_old_smap (old_smap), m_new_smap (new_smap),
-    m_stmt_finder (stmt_finder)
-  {
-  }
-
-  logger *get_logger () const { return m_logger.get_logger (); }
-
-  tree get_fndecl_for_call (const gcall *call) FINAL OVERRIDE
-  {
-    impl_region_model_context old_ctxt
-      (m_eg, m_enode_for_diag, NULL, NULL/*m_enode->get_state ()*/,
-       m_change, call);
-    region_model *model = m_new_state->m_region_model;
-    return model->get_fndecl_for_call (call, &old_ctxt);
-  }
-
-  void on_transition (const supernode *node  ATTRIBUTE_UNUSED,
-		      const gimple *stmt  ATTRIBUTE_UNUSED,
-		      tree var,
-		      state_machine::state_t from,
-		      state_machine::state_t to,
-		      tree origin) FINAL OVERRIDE
-  {
-    logger * const logger = get_logger ();
-    LOG_FUNC (logger);
-    impl_region_model_context old_ctxt
-      (m_eg, m_enode_for_diag, NULL, NULL/*m_enode->get_state ()*/,
-       m_change, stmt);
-    svalue_id var_old_sid
-      = m_old_state->m_region_model->get_rvalue (var, &old_ctxt);
-
-    impl_region_model_context new_ctxt (m_eg, m_enode_for_diag,
-					m_old_state, m_new_state,
-					m_change, NULL);
-    svalue_id var_new_sid
-      = m_new_state->m_region_model->get_rvalue (var, &new_ctxt);
-    svalue_id origin_new_sid
-      = m_new_state->m_region_model->get_rvalue (origin, &new_ctxt);
-
-    state_machine::state_t current = m_old_smap->get_state (var_old_sid);
-    if (current == from)
-      {
-	if (logger)
-	  logger->log ("%s: state transition of %qE: %s -> %s",
-		       m_sm.get_name (),
-		       var,
-		       m_sm.get_state_name (from),
-		       m_sm.get_state_name (to));
-	m_new_smap->set_state (m_new_state->m_region_model, var_new_sid,
-			       to, origin_new_sid);
-	if (m_change)
-	  m_change->add_sm_change (m_sm_idx, var_new_sid, from, to);
-      }
-  }
-
-  void warn_for_state (const supernode *snode, const gimple *stmt,
-		       tree var, state_machine::state_t state,
-		       pending_diagnostic *d) FINAL OVERRIDE
-  {
-    LOG_FUNC (get_logger ());
-    gcc_assert (d); // take ownership
-
-    impl_region_model_context old_ctxt
-      (m_eg, m_enode_for_diag, m_old_state, m_new_state, m_change, NULL);
-    state_machine::state_t current;
-    if (var)
-      {
-	svalue_id var_old_sid
-	  = m_old_state->m_region_model->get_rvalue (var, &old_ctxt);
-	current = m_old_smap->get_state (var_old_sid);
-      }
-    else
-      current = m_old_smap->get_global_state ();
-
-    if (state == current)
-      {
-	m_eg.get_diagnostic_manager ().add_diagnostic
-	  (&m_sm, m_enode_for_diag, snode, stmt, m_stmt_finder,
-	   var, NULL, state, d);
-      }
-    else
-      delete d;
-  }
-
-  /* Hook for picking more readable trees for SSA names of temporaries,
-     so that rather than e.g.
-       "double-free of '<unknown>'"
-     we can print:
-       "double-free of 'inbuf.data'".  */
-
-  tree get_diagnostic_tree (tree expr) FINAL OVERRIDE
-  {
-    /* Only for SSA_NAMEs of temporaries; otherwise, return EXPR, as it's
-       likely to be the least surprising tree to report.  */
-    if (TREE_CODE (expr) != SSA_NAME)
-      return expr;
-    if (SSA_NAME_VAR (expr) != NULL)
-      return expr;
-
-    gcc_assert (m_new_state);
-    svalue_id sid = m_new_state->m_region_model->get_rvalue (expr, NULL);
-    /* Find trees for all regions storing the value.  */
-    auto_vec<path_var> pvs;
-    m_new_state->m_region_model->get_path_vars_for_svalue (sid, &pvs);
-    if (pvs.length () < 1)
-      return expr;
-    /* Pick the "best" such tree.  */
-    // TODO: should we also consider (and consolidate) equiv classes?
-    pvs.qsort (readability_comparator);
-    return pvs[0].m_tree;
-  }
-
-  state_machine::state_t get_global_state () const FINAL OVERRIDE
-  {
-    return m_old_state->m_checker_states[m_sm_idx]->get_global_state ();
-  }
-
-  void set_global_state (state_machine::state_t state) FINAL OVERRIDE
-  {
-    m_new_state->m_checker_states[m_sm_idx]->set_global_state (state);
-  }
-
-  void on_custom_transition (custom_transition *transition) FINAL OVERRIDE
-  {
-    transition->impl_transition (&m_eg,
-				 const_cast<exploded_node *> (m_enode_for_diag),
-				 m_sm_idx);
-  }
-
-  tree is_zero_assignment (const gimple *stmt) FINAL OVERRIDE
-  {
-    const gassign *assign_stmt = dyn_cast <const gassign *> (stmt);
-    if (!assign_stmt)
-     return NULL_TREE;
-
-    enum tree_code op = gimple_assign_rhs_code (assign_stmt);
-    if (TREE_CODE_CLASS (op) != tcc_constant)
-      return NULL_TREE;
-
-    if (!zerop (gimple_assign_rhs1 (assign_stmt)))
-      return NULL_TREE;
-
-    return gimple_assign_lhs (assign_stmt);
-  }
-
-  log_user m_logger;
-  exploded_graph &m_eg;
-  const exploded_node *m_enode_for_diag;
-  const program_state *m_old_state;
-  program_state *m_new_state;
-  state_change *m_change;
-  const sm_state_map *m_old_smap;
-  sm_state_map *m_new_smap;
-  stmt_finder *m_stmt_finder;
-};
-
 // FIXME: revamped version:
 /* Concrete implementation of sm_context, wiring it up to the rest of this
    file.  */
@@ -513,7 +213,6 @@ public:
 		    const exploded_node *enode_for_diag,
 		    const program_state *old_state,
 		    program_state *new_state,
-		    state_change *change,
 		    const sm_state_map2 *old_smap,
 		    sm_state_map2 *new_smap,
 		    stmt_finder *stmt_finder = NULL)
@@ -521,7 +220,6 @@ public:
     m_logger (eg.get_logger ()),
     m_eg (eg), m_enode_for_diag (enode_for_diag),
     m_old_state (old_state), m_new_state (new_state),
-    m_change (change),
     m_old_smap (old_smap), m_new_smap (new_smap),
     m_stmt_finder (stmt_finder)
   {
@@ -533,7 +231,7 @@ public:
   {
     impl_region_model2_context old_ctxt
       (m_eg, m_enode_for_diag, NULL, NULL/*m_enode->get_state ()*/,
-       m_change, call);
+       call);
     region_model2 *model = m_new_state->m_region_model2;
     return model->get_fndecl_for_call (call, &old_ctxt);
   }
@@ -549,13 +247,13 @@ public:
     LOG_FUNC (logger);
     impl_region_model2_context old_ctxt
       (m_eg, m_enode_for_diag, NULL, NULL/*m_enode->get_state ()*/,
-       m_change, stmt);
+       stmt);
     const svalue2 *var_old_sval
       = m_old_state->m_region_model2->get_rvalue (var, &old_ctxt);
 
     impl_region_model2_context new_ctxt (m_eg, m_enode_for_diag,
 					 m_old_state, m_new_state,
-					 m_change, stmt);
+					 stmt);
     const svalue2 *var_new_sval
       = m_new_state->m_region_model2->get_rvalue (var, &new_ctxt);
     const svalue2 *origin_new_sval
@@ -588,7 +286,7 @@ public:
     gcc_assert (d); // take ownership
 
     impl_region_model2_context old_ctxt
-      (m_eg, m_enode_for_diag, m_old_state, m_new_state, m_change, NULL);
+      (m_eg, m_enode_for_diag, m_old_state, m_new_state, NULL);
     state_machine::state_t current;
     if (var)
       {
@@ -637,12 +335,12 @@ public:
 
   state_machine::state_t get_global_state () const FINAL OVERRIDE
   {
-    return m_old_state->m_checker_states[m_sm_idx]->get_global_state ();
+    return m_old_state->m_checker_states2[m_sm_idx]->get_global_state ();
   }
 
   void set_global_state (state_machine::state_t state) FINAL OVERRIDE
   {
-    m_new_state->m_checker_states[m_sm_idx]->set_global_state (state);
+    m_new_state->m_checker_states2[m_sm_idx]->set_global_state (state);
   }
 
   void on_custom_transition (custom_transition *transition) FINAL OVERRIDE
@@ -658,7 +356,7 @@ public:
     if (!assign_stmt)
      return NULL_TREE;
     impl_region_model2_context old_ctxt
-      (m_eg, m_enode_for_diag, m_old_state, m_new_state, m_change, stmt);
+      (m_eg, m_enode_for_diag, m_old_state, m_new_state, stmt);
     if (const svalue2 *sval
 	= m_new_state->m_region_model2->get_gassign_result (assign_stmt,
 							    &old_ctxt))
@@ -673,7 +371,6 @@ public:
   const exploded_node *m_enode_for_diag;
   const program_state *m_old_state;
   program_state *m_new_state;
-  state_change *m_change;
   const sm_state_map2 *m_old_smap;
   sm_state_map2 *m_new_smap;
   stmt_finder *m_stmt_finder;
@@ -841,223 +538,6 @@ readability_comparator (const void *p1, const void *p2)
   return 0;
 }
 
-/* Create an sm_context and use it to call SM's on_leak vfunc, so that
-   it can potentially complain about a leak of DST_SID (in a new region_model)
-   in the given STATE, where MAP can be used to map SID back to an "old"
-   region_model.  */
-
-void
-impl_region_model_context::on_state_leak (const state_machine &sm,
-					  int sm_idx,
-					  svalue_id dst_sid,
-					  svalue_id first_unused_sid,
-					  const svalue_id_map &map,
-					  state_machine::state_t state)
-{
-  logger * const logger = get_logger ();
-  LOG_SCOPE (logger);
-  if (logger)
-    logger->log ("considering leak of sv%i", dst_sid.as_int ());
-
-  if (!m_eg)
-    return;
-
-  /* m_old_state also needs to be non-NULL so that the sm_ctxt can look
-     up the old state of the sid.  */
-  gcc_assert (m_old_state);
-
-  /* Don't report on sid leaking if it's equal to one of the used sids.
-     For example, given:
-       some_non_trivial_expression = malloc (sizeof (struct foo));
-     we have:
-       _1 = malloc;                         (void *)
-       some_non_trivial_expression = _1;    (struct foo *)
-     and at leak-detection time we may have:
-       sv5: {type: 'struct foo *', &r3}  (used)
-       sv6: {type: 'void *', &r3}         (unused)
-     where both point to the same region.  We don't want to report a
-     leak of sv6, so we reject the report due to its equality with sv5.  */
-  gcc_assert (m_new_state);
-  gcc_assert (!first_unused_sid.null_p ());
-  for (int i = 0; i < first_unused_sid.as_int (); i++)
-    {
-      svalue_id used_sid = svalue_id::from_int (i);
-
-      /* Use the "_without_cm" form of eval_condition, since
-	 we're half-way through purging - we don't want to introduce new
-	 equivalence classes into the constraint_manager for "sid" and
-	 for each of the used_sids.  */
-      const region_model &rm = *m_new_state->m_region_model;
-      tristate eq = rm.eval_condition_without_cm (dst_sid, EQ_EXPR, used_sid);
-      if (eq.is_true ())
-	{
-	  if (logger)
-	    logger->log ("rejecting leak of sv%i due to equality with sv%i",
-			 dst_sid.as_int (), used_sid.as_int ());
-	  return;
-	}
-    }
-
-  /* SID has leaked within the new state: no regions use it.
-     We need to convert it back to a tree, but since no regions use it, we
-     have to use MAP to convert it back to an svalue_id within the old state.
-     We can then look that svalue_id up to locate regions and thus tree(s)
-     that use it.  */
-
-  svalue_id old_sid = map.get_src_for_dst (dst_sid);
-
-  auto_vec<path_var> leaked_pvs;
-  m_old_state->m_region_model->get_path_vars_for_svalue (old_sid, &leaked_pvs);
-
-  if (leaked_pvs.length () < 1)
-    return;
-
-  /* Find "best" leaked tree.
-     Sort the leaks into most human-readable first, through
-     to least user-readable.  Given that we only emit one
-     leak per EC, this ought to ensure that we pick the most
-     user-readable description of each leaking EC.
-     This assumes that all vars in the EC have the same state.  */
-  leaked_pvs.qsort (readability_comparator);
-
-  tree leaked_tree = leaked_pvs[0].m_tree;
-  if (logger)
-    logger->log ("best leaked_tree: %qE", leaked_tree);
-
-  leak_stmt_finder stmt_finder (*m_eg, leaked_tree);
-  impl_sm_context sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
-			   m_old_state, m_new_state,
-			   m_change,
-			   m_old_state->m_checker_states[sm_idx],
-			   m_new_state->m_checker_states[sm_idx],
-			   &stmt_finder);
-  gcc_assert (m_enode_for_diag);
-
-  /* Don't complain about leaks when returning from "main".  */
-  if (m_enode_for_diag->get_supernode ()
-      && m_enode_for_diag->get_supernode ()->return_p ())
-    {
-      tree fndecl = m_enode_for_diag->get_function ()->decl;
-      if (0 == strcmp (IDENTIFIER_POINTER (DECL_NAME (fndecl)), "main"))
-	{
-	  if (logger)
-	    logger->log ("not reporting leak from main");
-	  return;
-	}
-    }
-
-  pending_diagnostic *pd = sm.on_leak (leaked_tree);
-  if (pd)
-    m_eg->get_diagnostic_manager ().add_diagnostic
-      (&sm, m_enode_for_diag, m_enode_for_diag->get_supernode (),
-       m_stmt, &stmt_finder,
-       leaked_tree, NULL, state, pd);
-}
-
-/* Implementation of region_model_context::on_inherited_svalue vfunc
-   for impl_region_model_context.
-   Notify all checkers that CHILD_SID has been created from PARENT_SID,
-   so that those state machines that inherit state can propagate the state
-   from parent to child.  */
-
-void
-impl_region_model_context::on_inherited_svalue (svalue_id parent_sid,
-						svalue_id child_sid)
-{
-  if (!m_new_state)
-    return;
-
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = m_ext_state.get_sm (sm_idx);
-      if (sm.inherited_state_p ())
-	smap->on_inherited_svalue (parent_sid, child_sid);
-    }
-}
-
-/* Implementation of region_model_context::on_cast vfunc
-   for impl_region_model_context.
-   Notify all checkers that DST_SID is a cast of SRC_SID, so that sm-state
-   can be propagated from src to dst.  */
-
-void
-impl_region_model_context::on_cast (svalue_id src_sid,
-				    svalue_id dst_sid)
-{
-  if (!m_new_state)
-    return;
-
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    smap->on_cast (src_sid, dst_sid);
-}
-
-/* Implementation of region_model_context::on_condition vfunc.
-   Notify all state machines about the condition, which could lead to
-   state transitions.  */
-
-void
-impl_region_model_context::on_condition (tree lhs, enum tree_code op, tree rhs)
-{
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = m_ext_state.get_sm (sm_idx);
-      impl_sm_context sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
-			       m_old_state, m_new_state,
-			       m_change,
-			       m_old_state->m_checker_states[sm_idx],
-			       m_new_state->m_checker_states[sm_idx]);
-      sm.on_condition (&sm_ctxt,
-		       m_enode_for_diag->get_supernode (), m_stmt,
-		       lhs, op, rhs);
-    }
-}
-
-/* Implementation of region_model_context::on_phi vfunc.
-   Notify all state machines about the phi, which could lead to
-   state transitions.  */
-
-void
-impl_region_model_context::on_phi (const gphi *phi, tree rhs)
-{
-  int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
-    {
-      const state_machine &sm = m_ext_state.get_sm (sm_idx);
-      impl_sm_context sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
-			       m_old_state, m_new_state,
-			       m_change,
-			       m_old_state->m_checker_states[sm_idx],
-			       m_new_state->m_checker_states[sm_idx]);
-      sm.on_phi (&sm_ctxt, m_enode_for_diag->get_supernode (), phi, rhs);
-    }
-}
-
-/* Implementation of region_model_context::on_unexpected_tree_code vfunc.
-   Mark the new state as being invalid for further exploration.
-   TODO(stage1): introduce a warning for when this occurs.  */
-
-void
-impl_region_model_context::on_unexpected_tree_code (tree t,
-						    const dump_location_t &loc)
-{
-  logger * const logger = get_logger ();
-  if (logger)
-    logger->log ("unhandled tree code: %qs in %qs at %s:%i",
-		 t ? get_tree_code_name (TREE_CODE (t)) : "(null)",
-		 loc.get_impl_location ().m_function,
-		 loc.get_impl_location ().m_file,
-		 loc.get_impl_location ().m_line);
-  if (m_new_state)
-    m_new_state->m_valid = false;
-}
-
 // FIXME:
 /* Create an sm_context and use it to call SM's on_leak vfunc, so that
    it can potentially complain about a leak of SVAL in the given STATE.  */
@@ -1085,40 +565,6 @@ impl_region_model2_context::on_state_leak (const state_machine &sm,
      up the old state of SVAL.  */
   gcc_assert (m_old_state);
 
-#if 0
-  /* Don't report on sid leaking if it's equal to one of the used sids.
-     For example, given:
-       some_non_trivial_expression = malloc (sizeof (struct foo));
-     we have:
-       _1 = malloc;                         (void *)
-       some_non_trivial_expression = _1;    (struct foo *)
-     and at leak-detection time we may have:
-       sv5: {type: 'struct foo *', &r3}  (used)
-       sv6: {type: 'void *', &r3}         (unused)
-     where both point to the same region.  We don't want to report a
-     leak of sv6, so we reject the report due to its equality with sv5.  */
-  gcc_assert (m_new_state);
-  gcc_assert (!first_unused_sid.null_p ());
-  for (int i = 0; i < first_unused_sid.as_int (); i++)
-    {
-      svalue_id used_sid = svalue_id::from_int (i);
-
-      /* Use the "_without_cm" form of eval_condition, since
-	 we're half-way through purging - we don't want to introduce new
-	 equivalence classes into the constraint_manager for "sid" and
-	 for each of the used_sids.  */
-      const region_model &rm = *m_new_state->m_region_model;
-      tristate eq = rm.eval_condition_without_cm (dst_sid, EQ_EXPR, used_sid);
-      if (eq.is_true ())
-	{
-	  if (logger)
-	    logger->log ("rejecting leak of sv%i due to equality with sv%i",
-			 dst_sid.as_int (), used_sid.as_int ());
-	  return;
-	}
-    }
-#endif
-
   /* SVAL has leaked within the new state: it is not used by any reachable
      regions.
      We need to convert it back to a tree, but since it's likely no regions
@@ -1151,12 +597,6 @@ impl_region_model2_context::on_state_leak (const state_machine &sm,
     }
 
   leak_stmt_finder stmt_finder (*m_eg, leaked_tree);
-  impl_sm_context sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
-			   m_old_state, m_new_state,
-			   m_change,
-			   m_old_state->m_checker_states[sm_idx],
-			   m_new_state->m_checker_states[sm_idx],
-			   &stmt_finder);
   gcc_assert (m_enode_for_diag);
 
   // FIXME:
@@ -1189,13 +629,12 @@ void
 impl_region_model2_context::on_condition (tree lhs, enum tree_code op, tree rhs)
 {
   int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
+  sm_state_map2 *smap;
+  FOR_EACH_VEC_ELT (m_new_state->m_checker_states2, sm_idx, smap)
     {
       const state_machine &sm = m_ext_state.get_sm (sm_idx);
       impl_sm_context2 sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
 				m_old_state, m_new_state,
-				m_change,
 				m_old_state->m_checker_states2[sm_idx],
 				m_new_state->m_checker_states2[sm_idx]);
       sm.on_condition (&sm_ctxt,
@@ -1212,13 +651,12 @@ void
 impl_region_model2_context::on_phi (const gphi *phi, tree rhs)
 {
   int sm_idx;
-  sm_state_map *smap;
-  FOR_EACH_VEC_ELT (m_new_state->m_checker_states, sm_idx, smap)
+  sm_state_map2 *smap;
+  FOR_EACH_VEC_ELT (m_new_state->m_checker_states2, sm_idx, smap)
     {
       const state_machine &sm = m_ext_state.get_sm (sm_idx);
       impl_sm_context2 sm_ctxt (*m_eg, sm_idx, sm, m_enode_for_diag,
 				m_old_state, m_new_state,
-				m_change,
 				m_old_state->m_checker_states2[sm_idx],
 				m_new_state->m_checker_states2[sm_idx]);
       sm.on_phi (&sm_ctxt, m_enode_for_diag->get_supernode (), phi, rhs);
@@ -1260,20 +698,19 @@ point_and_state::validate (const extrinsic_state &ext_state) const
 
   m_state.validate (ext_state);
 
-  if (!m_state.m_region_model)
-    return;
-
   /* Verify that the callstring's model of the stack corresponds to that
      of the region_model.  */
   /* They should have the same depth.  */
   gcc_assert (m_point.get_stack_depth ()
-	      == m_state.m_region_model->get_stack_depth ());
+	      == m_state.m_region_model2->get_stack_depth ());
   /* Check the functions in the callstring vs those in the frames
      at each depth.  */
   for (int depth = 0; depth < m_point.get_stack_depth (); ++depth)
     {
+#if 0
       gcc_assert (m_point.get_function_at_depth (depth)
-		  == m_state.m_region_model->get_function_at_depth (depth));
+		  == m_state.m_region_model2->get_function_at_depth (depth));
+#endif
     }
 }
 
@@ -1368,8 +805,6 @@ exploded_node::exploded_node (const point_and_state &ps,
 : m_ps (ps), m_status (STATUS_WORKLIST), m_index (index),
   m_num_processed_stmts (0)
 {
-  if (ps.get_state ().m_region_model)
-    gcc_checking_assert (ps.get_state ().m_region_model->canonicalized_p ());
   if (ps.get_state ().m_region_model2)
     gcc_checking_assert (ps.get_state ().m_region_model2->canonicalized_p ());
 }
@@ -1405,18 +840,6 @@ exploded_node::get_dot_fillcolor () const
      Sum the sm_states, and use the result to choose from a table,
      modulo table-size, special-casing the "no sm-state" case.   */
   int total_sm_state = 0;
-  {
-    int i;
-    sm_state_map *smap;
-    FOR_EACH_VEC_ELT (state.m_checker_states, i, smap)
-      {
-	for (sm_state_map::iterator_t iter = smap->begin ();
-	     iter != smap->end ();
-	     ++iter)
-	  total_sm_state += (*iter).second.m_state;
-	total_sm_state += smap->get_global_state ();
-      }
-  }
   {
     int i;
     sm_state_map2 *smap;
@@ -1493,20 +916,6 @@ exploded_node::dump_dot (graphviz_out *gv, const dump_args_t &args) const
       const program_state &state = m_ps.get_state ();
       state.dump_to_pp (ext_state, false, true, pp);
       pp_newline (pp);
-
-      {
-	int i;
-	sm_state_map *smap;
-	FOR_EACH_VEC_ELT (state.m_checker_states, i, smap)
-	  {
-	    if (!smap->is_empty_p ())
-	      {
-		pp_printf (pp, "%s: ", ext_state.get_name (i));
-		smap->print (ext_state.get_sm (i), state.m_region_model, pp);
-		pp_newline (pp);
-	      }
-	  }
-      }
     }
 
   /* Dump any saved_diagnostics at this enode.  */
